$regfile = "attiny2313.dat"
$crystal = 2000000

Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinb.2 = Output
Config Pinb.3 = Output
Config Pinb.4 = Output
Config Pinb.5 = Input                                       'Kropka i przycisk zerowania
Config Pinb.6 = Input
Config Pinb.7 = Input
Config Pind.0 = Input
Config Pind.1 = Output
Config Pind.2 = Output
Config Pind.3 = Output
Config Pind.4 = Output
Config Pind.5 = Output
Config Pind.6 = Output


Sw Alias Pind.0
Ca Alias Portd.4
Cb Alias Portd.2
Cc Alias Portd.1
Cd Alias Portd.3
Dp Alias Portb.5
Blank Alias Portd.5
An1 Alias Portd.6
An2 Alias Portb.0
An3 Alias Portb.1
An4 Alias Portb.2
An5 Alias Portb.3
An6 Alias Portb.4
Ctrl Alias Pinb.6
Pwr Alias Pinb.7

Config Timer0 = Timer , Prescale = 8
Enable Interrupts
On Timer0 Czas

Dim Nr As Byte
Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim D As Byte
Dim E As Byte
Dim F As Byte
Dim Sekundy As Byte
Dim Minuty As Byte
Dim Godziny As Byte
Dim Doby As Byte
Dim Mem(4) As Eram Byte                                     'Dane w EEPROMie
Dim 1ms As Integer                                          'licznik odcinkw 1ms
Dim Mig As Bit                                              'Miganie kropk
Dim Odsw As Bit                                             'Odwieanie
Dim Saved As Bit                                            'Czy dane zostay ju zapisane?

Nr = 1
A = 10
B = 10
C = 10
D = 10
E = 10
F = 10
Set Dp
Set Odsw
Set Portd.0                                                 'Pull-up do przecznika
Set Portb.6                                                 'Pull-up do wejcia pauzy
Timer0 = 6
Set An1
Set An2
Set An3
Set An4
Set An5
Set An6


'Przy pierwszym uruchomieniu dane w EEPROMie s ustawione na 255 - trzeba je wtedy wyzerowa

If Mem(1) = 255 Or Pinb.5 = 0 Then
   Mem(1) = 0
   Bitwait Eecr.1 , Reset
   Mem(2) = 0
   Bitwait Eecr.1 , Reset
   Mem(3) = 0
   Bitwait Eecr.1 , Reset
   Mem(4) = 0
   Bitwait Eecr.1 , Reset
Else
   'Wczytaj dane z EEPROMu
   Doby = Mem(1)
   Godziny = Mem(2)
   Minuty = Mem(3)
   Sekundy = Mem(4)
End If

Config Pinb.5 = Output                                      'Teraz PB5 steruje kropk

Enable Timer0

Do
'W przypadku braku zasilania rzu wszystko i zapisz dane do EEPROMu

If Pwr = 0 And Saved = 0 Then
   Disable Timer0                                           'Zatrzymaj Timer0
   Set Blank
   Reset Ca
   Reset Cb
   Reset Cc
   Reset Cd
   Set Dp
   Set An1
   Set An2
   Set An3
   Set An4
   Set An5
   Set An6

   Mem(1) = Doby
   Bitwait Eecr.1 , Reset
   Mem(2) = Godziny
   Bitwait Eecr.1 , Reset
   Mem(3) = Minuty
   Bitwait Eecr.1 , Reset
   Mem(4) = Sekundy
   Bitwait Eecr.1 , Reset
   Reset Saved
   Enable Timer0                                            'Krtka przerwa w zasilaniu nie musi spowodowa resetu - wtedy wr do normalnej pracy
End If

'Odwieanie wywietlaczy
If Odsw = 1 Then
   Reset Odsw
   A = Makebcd(doby)
   B = A And &B00001111
   A = A And &B11110000
   Shift A , Right , 4
   C = Makebcd(godziny)
   D = C And &B00001111
   C = C And &B11110000
   Shift C , Right , 4
   E = Makebcd(minuty)
   F = E And &B00001111
   E = E And &B11110000
   Shift E , Right , 4
End If

Loop
End

Czas:                                                       'Wywoywane 1 kHz
Timer0 = 6

If Ctrl = 1 Then
   Incr 1ms
   If 1ms = 1000 Then
      1ms = 0
      Toggle Mig
      Incr Sekundy
      If Sekundy = 60 Then
         Sekundy = 0
         Incr Minuty
         Set Odsw
         If Minuty = 60 Then
            Minuty = 0
            Incr Godziny
            If Godziny = 60 Then
               Godziny = 0
               Incr Doby
               If Doby = 100 Then
                  Doby = 0
               End If
            End If
         End If
      End If
   End If
End If

'Wyczanie wywietlaczy
If Sw = 0 Then
   Nr = 0
End If

'Flaga SAVED - przywracana po powrocie zasilania gdyby procesor si nie zresetowa
If Pwr = 1 And Saved = 1 Then
   Reset Saved
End If

Set An1
Set An2
Set An3
Set An4
Set An5
Set An6
Set Dp
Set Blank
If Nr = 1 Then
   Nr = 2
   Ca = A.0
   Cb = A.1
   Cc = A.2
   Cd = A.3
   Reset An1
Elseif Nr = 2 Then
   Nr = 3
   Ca = B.0
   Cb = B.1
   Cc = B.2
   Cd = B.3
   If Ctrl = 1 Then
      Dp = Mig
   End If
   Reset An2
Elseif Nr = 3 Then
   Nr = 4
   Ca = C.0
   Cb = C.1
   Cc = C.2
   Cd = C.3
   Reset An3
Elseif Nr = 4 Then
   Nr = 5
   Ca = D.0
   Cb = D.1
   Cc = D.2
   Cd = D.3
   If Ctrl = 1 Then
      Dp = Mig
   End If
   Reset An4
Elseif Nr = 5 Then
   Nr = 6
   Ca = E.0
   Cb = E.1
   Cc = E.2
   Cd = E.3
   Reset An5
Elseif Nr = 6 Then
   Nr = 1
   Ca = F.0
   Cb = F.1
   Cc = F.2
   Cd = F.3
   If Ctrl = 1 Then
      Dp = Mig
   End If
   Reset An6
Elseif Nr = 0 And Sw = 1 Then                               'Wczanie wywietlaczy
   Nr = 1
End If
Reset Blank
Return